"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadSPCore = void 0;
var executor_1 = require("../executor");
/**
 * Loads the core SharePoint JavaScript library for JSOM.
 */
exports.loadSPCore = function (additionalLibs) {
    // Return a promise
    return new Promise(function (resolve) {
        // Define the core libraries to load
        var libs = ["init", "MicrosoftAjax", "SP.Runtime", "SP", "SP.Init"];
        // See if we are loading additional libraries
        if (additionalLibs && additionalLibs.length > 0) {
            // Append the libs
            libs = libs.concat(additionalLibs);
        }
        // Parse the libraries
        var counter = 0;
        executor_1.Executor(libs, function (libName) {
            // Return a promise
            return new Promise(function (resolve) {
                // See if a script already exists
                if (document.querySelector("script[title='" + libName + "']") == null) {
                    // Log
                    console.debug("[gd-sprest] Loading the core library: " + libName);
                    // Create the script element to load the library
                    var elScript_1 = document.createElement("script");
                    elScript_1.title = libName;
                    elScript_1.src = document.location.origin + "/_layouts/15/" + libName + ".js";
                    // Wait for the previous library to load
                    setTimeout(function () {
                        // Load the script
                        document.head.appendChild(elScript_1);
                        // Resolve the request
                        resolve(null);
                    }, 10 * counter++);
                }
                else {
                    // Log
                    console.debug("[gd-sprest] Core library already loaded: " + libName);
                }
            }).then(function () {
                // Resolve the request after all the libraries have been requested
                resolve();
            });
        });
    });
};
