"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setWebProperty = void 0;
/**
 * Adds or updates a key/value pair for a web's property bag
 * This uses JSOM to set a web's property. The REST API doesn't support this at the moment.
 */
exports.setWebProperty = function (key, value, siteUrl) {
    // Return a promise
    return new Promise(function (resolve, reject) {
        // Get the site groups
        var context = siteUrl ? new SP.ClientContext(siteUrl) : SP.ClientContext.get_current();
        var web = context.get_web();
        var allProps = web.get_allProperties();
        // Set the property
        allProps.set_item(key, value);
        // Save the changes
        context.load(web);
        web.update();
        // Execute the request
        context.executeQueryAsync(resolve, reject);
    });
};
