"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MapperV2 = void 0;
var utils_1 = require("../utils");
/**
 * Mapper for the v2 api.
 */
exports.MapperV2 = {
    activity: {
        driveItem: {
            requestType: utils_1.RequestType.Get,
            returnType: "driveItem"
        },
        listItem: {
            requestType: utils_1.RequestType.Get,
            returnType: "listItem"
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    column: {
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
        update: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        }
    },
    columns: {
        add: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    contentType: {
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
        update: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        }
    },
    contentTypes: {
        add: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    drive: {
        activities: {
            requestType: utils_1.RequestType.Get
        },
        activitycounts: {
            requestType: utils_1.RequestType.Get
        },
        apps: {
            requestType: utils_1.RequestType.Get
        },
        commands: {
            requestType: utils_1.RequestType.Get
        },
        items: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "items"
        },
        list: {
            requestType: utils_1.RequestType.Get,
            returnType: "list"
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
        special: {
            requestType: utils_1.RequestType.Get
        },
        trackedItems: {
            requestType: utils_1.RequestType.Get
        }
    },
    item: {
        permissions: {
            requestType: utils_1.RequestType.Get
        },
        children: {
            requestType: utils_1.RequestType.Get
        },
        subscriptions: {
            requestType: utils_1.RequestType.Get
        },
        thumbnails: {
            requestType: utils_1.RequestType.Get
        },
        activities: {
            requestType: utils_1.RequestType.Get
        },
        analytics: {
            requestType: utils_1.RequestType.Get
        },
        commands: {
            requestType: utils_1.RequestType.Get
        },
        featureStatus: {
            requestType: utils_1.RequestType.Get
        },
        listItem: {
            requestType: utils_1.RequestType.Get
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
        update: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        versions: {
            requestType: utils_1.RequestType.Get
        }
    },
    list: {
        activities: {
            requestType: utils_1.RequestType.Get
        },
        columns: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "columns",
        },
        contentTypes: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "contentTypes"
        },
        drive: {
            requestType: utils_1.RequestType.Get,
            returnType: "drive"
        },
        items: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "listItems"
        },
        update: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    listItem: {
        activities: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "activities"
        },
        analytics: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "analytics"
        },
        driveItem: {
            requestType: utils_1.RequestType.Get,
            returnType: "driveItem"
        },
        fields: {
            appendRequest: true,
            requestType: utils_1.RequestType.Get,
            name: "([base.id])/fields",
            returnType: "fields"
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
        permissions: {
            requestType: utils_1.RequestType.Get
        },
        update: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        versions: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "versions"
        },
    },
    listItems: {
        add: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    listItemVersion: {
        fields: {
            requestType: utils_1.RequestType.Get,
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    lists: {
        add: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        analytics: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "analytics"
        },
        columns: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "columns"
        },
        contentTypes: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "contentTypes"
        },
        drive: {
            requestType: utils_1.RequestType.Get,
            returnType: "drive"
        },
        getById: {
            argNames: ["id"],
            name: "[[id]]",
            requestType: utils_1.RequestType.GetReplace,
            returnType: "list"
        },
        getByTitle: {
            argNames: ["title"],
            name: "[[title]]",
            requestType: utils_1.RequestType.GetReplace,
            returnType: "list"
        },
        items: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "listItems"
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    permission: {
        update: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    permissions: {
        add: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
    },
    sites: {
        add: {
            args: ["values"],
            name: "",
            requestType: utils_1.RequestType.PostBodyNoArgs
        },
        analytics: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "analytics"
        },
        columns: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "columns"
        },
        contentTypes: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "contentTypes"
        },
        drive: {
            requestType: utils_1.RequestType.Get,
            returnType: "drive"
        },
        drives: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "drives"
        },
        items: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "listItems"
        },
        lists: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "lists"
        },
        query: { argNames: ["oData"], requestType: utils_1.RequestType.OData },
        permissions: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "permissions"
        },
        sites: {
            requestType: utils_1.RequestType.GetWithArgsValueOnly,
            returnType: "sites"
        }
    }
};
